Attribute VB_Name = "Module1"
Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cX As Long, ByVal cY As Long, ByVal wFlags As Long) As Long

Public Declare Function GetSystemMenu Lib "user32" _
    (ByVal hWnd As Long, _
     ByVal bRevert As Long) As Long
Public Declare Function RemoveMenu Lib "user32" _
    (ByVal hMenu As Long, _
     ByVal nPosition As Long, _
     ByVal wFlags As Long) As Long
Public Const MF_BYPOSITION = &H400&


Public Const HWND_TOPMOST = -1
Public Const SWP_SHOWWINDOW = &H40

Public Sub DisableCloseWindowButton(frm As Form)
    Dim hSysMenu As Long
    hSysMenu = GetSystemMenu(frm.hWnd, 0)
    RemoveMenu hSysMenu, 6, MF_BYPOSITION
    RemoveMenu hSysMenu, 5, MF_BYPOSITION
End Sub


Public Function Eng2Rus(Text As String) As String
Dim S As String
Dim D As String
Dim N As Long
Dim CS As Long
Dim Txt As String
Txt = ""
Lg = Len(Text)
For N = 1 To Lg
S = Mid$(Text, N, 1)
CS = GetCharSize(S)
S = UCase(S)
Select Case S
Case "Q"
S = ""
Case "W"
S = ""
Case "E"
S = ""
Case "R"
S = ""
Case "T"
S = ""
Case "Y"
S = ""
Case "U"
S = ""
Case "I"
S = ""
Case "O"
S = ""
Case "P"
S = ""
Case "["
S = ""
Case "]"
S = ""
Case "A"
S = ""
Case "S"
S = ""
Case "D"
S = ""
Case "F"
S = ""
Case "G"
S = ""
Case "H"
S = ""
Case "J"
S = ""
Case "K"
S = ""
Case "L"
S = ""
Case ";"
S = ""
Case "'"
S = ""
Case "Z"
S = ""
Case "X"
S = ""
Case "C"
S = ""
Case "V"
S = ""
Case "B"
S = ""
Case "N"
S = ""
Case "M"
S = ""
Case ","
S = ""
Case "."
S = ""
Case "#"
S = ""
Case "$"
S = ";"
Case "^"
S = ":"
Case "/"
S = "."
Case "?"
S = ","
Case "`"
S = ""
End Select
If CS = 0 Then Txt = Txt & LCase(S)
If CS = 1 Then Txt = Txt & UCase(S)
Next
Eng2Rus = Txt
End Function

Public Function Rus2Eng(Text As String) As String
Dim S As String
Dim D As String
Dim N As Long
Dim CS As Long
Dim Txt As String
Txt = ""
Lg = Len(Text)
For N = 1 To Lg
S = Mid$(Text, N, 1)
CS = GetCharSize(S)
S = UCase(S)
Select Case S
Case ""
S = "Q"
Case ""
S = "W"
Case ""
S = "E"
Case ""
S = "R"
Case ""
S = "T"
Case ""
S = "Y"
Case ""
S = "U"
Case ""
S = "I"
Case ""
S = "O"
Case ""
S = "P"
Case ""
S = "["
Case ""
S = "]"
Case ""
S = "A"
Case ""
S = "S"
Case ""
S = "D"
Case ""
S = "F"
Case ""
S = "G"
Case ""
S = "H"
Case ""
S = "J"
Case ""
S = "K"
Case ""
S = "L"
Case ""
S = ";"
Case ""
S = "'"
Case ""
S = "Z"
Case ""
S = "X"
Case ""
S = "C"
Case ""
S = "V"
Case ""
S = "B"
Case ""
S = "N"
Case ""
S = "M"
Case ""
S = ","
Case ""
S = "."
Case ""
S = "`"
Case ""
S = "#"
Case ";"
S = "$"
Case ":"
S = "^"
Case "?"
S = "&"
Case "."
S = "/"
Case ","
S = "?"
End Select
If CS = 0 Then Txt = Txt & LCase(S)
If CS = 1 Then Txt = Txt & UCase(S)
Next
Rus2Eng = Txt
End Function
Public Function ReversEngRus(Chr As String) As String
Dim S As String
S = Chr
CS = GetCharSize(S)
S = UCase(S)
Select Case S
Case "Q"
S = ""
Case "W"
S = ""
Case "E"
S = ""
Case "R"
S = ""
Case "T"
S = ""
Case "Y"
S = ""
Case "U"
S = ""
Case "I"
S = ""
Case "O"
S = ""
Case "P"
S = ""
Case "["
S = ""
Case "]"
S = ""
Case "A"
S = ""
Case "S"
S = ""
Case "D"
S = ""
Case "F"
S = ""
Case "G"
S = ""
Case "H"
S = ""
Case "J"
S = ""
Case "K"
S = ""
Case "L"
S = ""
Case "'"
S = ""
Case "Z"
S = ""
Case "X"
S = ""
Case "C"
S = ""
Case "V"
S = ""
Case "B"
S = ""
Case "N"
S = ""
Case "M"
S = ""
Case ","
S = ""
Case "."
S = ""
Case ""
S = "Q"
Case ""
S = "W"
Case ""
S = "E"
Case ""
S = "R"
Case ""
S = "T"
Case ""
S = "Y"
Case ""
S = "U"
Case ""
S = "I"
Case ""
S = "O"
Case ""
S = "P"
Case ""
S = "["
Case ""
S = "]"
Case ""
S = "A"
Case ""
S = "S"
Case ""
S = "D"
Case ""
S = "F"
Case ""
S = "G"
Case ""
S = "H"
Case ""
S = "J"
Case ""
S = "K"
Case ""
S = "L"
Case ""
S = ";"
Case ""
S = "'"
Case ""
S = "Z"
Case ""
S = "X"
Case ""
S = "C"
Case ""
S = "V"
Case ""
S = "B"
Case ""
S = "N"
Case ""
S = "M"
Case ""
S = ","
Case ""
S = "."
Case ""
S = "`"
Case ""
S = "#"
Case ";"
S = "$"
Case ":"
S = "^"
Case "?"
S = "&"
Case "."
S = "/"
Case ","
S = "?"
Case "#"
S = ""
Case "$"
S = ";"
Case "^"
S = ":"
Case "/"
S = "."
Case "?"
S = ","
Case "`"
S = ""
End Select
If CS = 0 Then S = LCase(S)
ReversEngRus = S
End Function
Public Function GetCharSize(Chr As String)
If UCase(Chr) = Chr Then
GetCharSize = 1
Else
GetCharSize = 0
End If
End Function

