VERSION 5.00
Begin VB.Form frmImageLink 
   BackColor       =   &H00C0FFFF&
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   5310
   ClientLeft      =   15
   ClientTop       =   15
   ClientWidth     =   2400
   ControlBox      =   0   'False
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmImageLink.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5310
   ScaleWidth      =   2400
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdPreview 
      Caption         =   "&Preview >>"
      Height          =   375
      Left            =   120
      TabIndex        =   9
      Top             =   4800
      Width           =   2175
   End
   Begin VB.PictureBox picTitle 
      Align           =   1  'Align Top
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   0
      ScaleHeight     =   225
      ScaleWidth      =   2370
      TabIndex        =   7
      Top             =   0
      Width           =   2400
      Begin VB.Label lblTitle 
         BackStyle       =   0  'Transparent
         Caption         =   "Image Link"
         BeginProperty Font 
            Name            =   "Verdana"
            Size            =   9
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   0
         TabIndex        =   8
         Top             =   0
         Width           =   1215
      End
   End
   Begin VB.CommandButton cmdOK 
      Appearance      =   0  'Flat
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   4320
      Width           =   975
   End
   Begin VB.DriveListBox Drive1 
      Appearance      =   0  'Flat
      Height          =   315
      Left            =   120
      TabIndex        =   1
      Top             =   360
      Width           =   2175
   End
   Begin VB.DirListBox Dir1 
      Appearance      =   0  'Flat
      Height          =   1440
      Left            =   120
      TabIndex        =   2
      Top             =   720
      Width           =   2175
   End
   Begin VB.ComboBox Combo1 
      Appearance      =   0  'Flat
      Height          =   315
      Left            =   120
      TabIndex        =   0
      Top             =   3840
      Width           =   2175
   End
   Begin VB.FileListBox File1 
      Appearance      =   0  'Flat
      Height          =   1395
      Left            =   120
      Pattern         =   "*.bmp;*.gif;*.jpg;*.jpeg;*.png"
      TabIndex        =   3
      Top             =   2280
      Width           =   2175
   End
   Begin VB.CommandButton cmdCancel 
      Appearance      =   0  'Flat
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   1320
      TabIndex        =   5
      Top             =   4320
      Width           =   975
   End
   Begin VB.PictureBox Picture1 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   855
      Left            =   720
      ScaleHeight     =   53
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   53
      TabIndex        =   6
      TabStop         =   0   'False
      Top             =   4200
      Visible         =   0   'False
      Width           =   855
   End
   Begin VB.Image Image1 
      BorderStyle     =   1  'Fixed Single
      Height          =   1815
      Left            =   2400
      Stretch         =   -1  'True
      Top             =   360
      Width           =   2415
   End
End
Attribute VB_Name = "frmImageLink"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'    Blue Ice HTML Editor
'    Copyright (C) 1999  Joel Dueck
'
'    This program is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

Option Explicit
Dim ImgLoaded As Boolean
Dim ImgW%, ImgH%

Private Locked As Boolean
Private Filename_Locked As Boolean
Private ShowPreview As Boolean

' Used for easily switching the preview and normal widths
Const NORMAL_WIDTH = 2430
Const PREVIEW_WIDTH = 4920

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdOK_Click()
Dim I$, F$, ImgFile$
    F$ = Combo1.Text
    
    If Len(F$) = 0 Then
        Exit Sub
    End If
    
    ImgFile = File1.Path & "\" & F$
    
    If Len(Dir(ImgFile$)) > 0 Then
        ' Load the file
        With Picture1
            .Picture = LoadPicture(ImgFile$)
            ImgH = CInt(.ScaleY(.Picture.Height, 8, 3))
            ImgW = CInt(.ScaleX(.Picture.Width, 8, 3))
            ImgLoaded = True
        End With
        
        ' Create a tag, with automatic width &
        ' height params, and relative pathname
        F$ = GetRelativePath(frmMain.CurrentDoc.Filename, ImgFile)
        
        I$ = "<IMG src=" & Chr$(34) & F$ & Chr$(34) & _
            " width=" & QuoteStr(CStr(ImgW)) & " height=" & QuoteStr(CStr(ImgH)) & _
            " border=" & QuoteStr("0") & ">"
    Else
        ' Can't find the file, so create a dumb tag
        I$ = "<IMG src=" & Chr$(34) & F$ & Chr$(34) & "border=" & QuoteStr("0") & ">"
    End If
    
    ' Insert the tag
    frmMain.CurrentDoc.rtText.SelText = I$
    
    ' Remember this directory, path
    ImgPath = Dir1.Path
    ImgDrive = Left$(Drive1.Drive, 2)
    Unload Me
End Sub

Private Sub cmdPreview_Click()
    If ShowPreview Then
        Me.Width = NORMAL_WIDTH
        cmdPreview.Caption = "&Preview >>"
        ShowPreview = False
        SetTitlebar picTitle, lblTitle
    Else
        Me.Width = PREVIEW_WIDTH
        cmdPreview.Caption = "<< &Hide"
        ShowPreview = True
        SetTitlebar picTitle, lblTitle
    End If
End Sub

Private Sub Combo1_Change()
Static T$
    If Locked Then Exit Sub
    If Len(Combo1.Text) > Len(T$) Then      ' user did not delete text
        T$ = Combo1.Text
        Locked = True
        AutoComplete Combo1
        Locked = False
    Else
        T$ = Combo1.Text
    End If
End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
Dim I%
On Error Resume Next

    If KeyCode = vbKeyF6 Then
        FastDir
        
    ElseIf KeyCode = vbKeyF5 Then
        Drive1.Refresh
        Dir1.Refresh
        File1.Refresh
        
        FillCombo
    End If
End Sub

Private Sub lblTitle_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Dim lReturn As Long
       Call ReleaseCapture
       lReturn = SendMessage(Me.hWnd, WM_SYSCOMMAND, MOUSE_MOVE, 0)
End Sub

Private Sub picTitle_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Dim lReturn As Long
       Call ReleaseCapture
       lReturn = SendMessage(Me.hWnd, WM_SYSCOMMAND, MOUSE_MOVE, 0)
End Sub

Private Sub Form_Load()
On Error Resume Next
    ScaleMode = 3
    If Len(ImgDrive) > 0 Then Drive1.Drive = ImgDrive
    If Len(ImgPath) > 0 Then Dir1.Path = ImgPath
    SetTitlebar picTitle, lblTitle
    FillCombo
End Sub

Private Sub File1_Click()
    With Picture1
        .Picture = LoadPicture(File1.Path & "\" & File1.Filename)
        ImgH = CInt(.ScaleY(.Picture.Height, 8, 3))
        ImgW = CInt(.ScaleX(.Picture.Width, 8, 3))
        Set Image1.Picture = .Picture
        ImgLoaded = True
    End With
    
    With Combo1
        Combo1.Text = File1.Filename
        If Not InList(Combo1, .Text) Then
            Combo1.AddItem .Text
        End If
    End With
End Sub

' Synchronize the File list when the directory changes
'
Private Sub Dir1_Change()
    File1.Path = Dir1.Path
    FillCombo
End Sub

Private Sub Drive1_Change()
    If Not Locked Then
        Dir1.Path = Drive1.Drive
    End If
End Sub

Private Sub FillCombo()
Dim I%
    ' Add all files to list box for AutoComplete
    With Combo1
        .Clear
        For I = 0 To File1.ListCount - 1
            .AddItem File1.List(I)
        Next I
    End With
End Sub

' Sub called by Form_KeyUp when user wants to switch active
' directories
'
Private Sub FastDir()
Dim A$, C$, D$
    With frmContextInput
        ' Set up the input box
        .Top = Me.Top + (Me.Height / 2)
        .Left = Me.Left
        .Prompt = "Enter Directory"
        .SetList MRUDirs
        .Show vbModal, Me

        If .Canceled Then
            Exit Sub
        End If
        
        A$ = .Text
        C$ = Dir1.Path  ' Save the path
        D$ = Left$(Dir1.Path, 1)
        
        Dir1.Path = A$  ' Set the new path
        
        ' If the path actually changed, and this is a
        ' new dir name, add it to the autocomplete list.
        '
        If C$ <> Dir1.Path And Not InList(MRUDirs, A$) Then
            MRUDirs.Add A$
        End If
        
        ' Change drives if necessary
        If D$ <> Left$(Dir1.Path, 1) Then
            Locked = True   ' Prevent Change event
            Drive1.Drive = Left$(Dir1.Path, 1)
            Locked = False
        End If
    End With
End Sub
