VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.1#0"; "RICHTX32.OCX"
Begin VB.Form frmDoc 
   Caption         =   "Document"
   ClientHeight    =   3510
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   6675
   Icon            =   "frmMain.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form2"
   MDIChild        =   -1  'True
   ScaleHeight     =   3510
   ScaleWidth      =   6675
   Begin VB.Timer Timer1 
      Interval        =   100
      Left            =   1440
      Top             =   2760
   End
   Begin RichTextLib.RichTextBox rtText 
      Height          =   2535
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   5415
      _ExtentX        =   9551
      _ExtentY        =   4471
      _Version        =   327681
      BorderStyle     =   0
      HideSelection   =   0   'False
      ScrollBars      =   2
      Appearance      =   0
      TextRTF         =   $"frmMain.frx":08CA
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Verdana"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.CommandButton cmdDummy 
      Caption         =   "Command1"
      Height          =   375
      Left            =   5640
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   1680
      Width           =   1095
   End
End
Attribute VB_Name = "frmDoc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'    Blue Ice HTML Editor
'    Copyright (C) 1999  Joel Dueck
'
'    This program is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

Option Explicit

' These UDTs used for bug-free printing (as opposed to the default
' bug-full printing using .SelText)
'
Private Type Rect
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Private Type CharRange
  cpMin As Long     ' First character of range (0 for start of doc)
  cpMax As Long     ' Last character of range (-1 for end of doc)
End Type

Private Type FormatRange
  hdc As Long       ' Actual DC to draw on
  hdcTarget As Long ' Target DC for determining text formatting
  rc As Rect        ' Region of the DC to draw to (in twips)
  rcPage As Rect    ' Region of the entire DC (page size) (in twips)
  chrg As CharRange ' Range of text to draw (see above declaration)
End Type

Private Const WM_USER As Long = &H400
Private Const EM_FORMATRANGE As Long = WM_USER + 57
Private Const EM_SETTARGETDEVICE As Long = WM_USER + 72
Private Const PHYSICALOFFSETX As Long = 112
Private Const PHYSICALOFFSETY As Long = 113
Const WM_PASTE = &H302

Private Declare Function GetDeviceCaps Lib "gdi32" ( _
   ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function CreateDC Lib "gdi32" Alias "CreateDCA" _
   (ByVal lpDriverName As String, ByVal lpDeviceName As String, _
   ByVal lpOutput As Long, ByVal lpInitData As Long) As Long

' Document Properties
Public Filename As String   ' Filename of this document
Public Tempname As String   ' For temporary saving
Public CtlKey As Boolean    ' Keeps track of CTRL key state
Public Modified As Boolean  ' Whether this document was modified
Public Unsaved As Boolean   ' Whether   "  was *ever* saved
Public DocKey As String     ' Unique identifier for this session
Public IsTemplate As Boolean    ' Whether started from a template

' Used in multi-level undo/redo scheme
Private trapUndo As Boolean         ' Locks the document while
                                    ' undo/redo is performed

Public UndoStack As New Collection
Public RedoStack As New Collection

Private Locked As Boolean

Private Sub Form_Activate()
    Set frmMain.CurrentDoc = Me
    frmMain.UpdateUndoFunctions
    Me.SetModified Modified     ' Update modified status on toolbar/status bar
    rtText_SelChange            ' Update edit functions on toolbar
    rtText.Refresh
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyControl Then
        CtlKey = True
    End If
End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyControl Then
        CtlKey = False
    ElseIf KeyCode = vbKeyF12 Then
        rtText.SelText = "http://"
    End If
End Sub

Private Sub Form_Load()
Dim DocCount%
    DocCount = frmMain.Documents.Count
    
    If DocMaximized Then
        Me.WindowState = vbMaximized
    End If
    
    Set frmMain.CurrentDoc = Me
    If frmMain.NoDocs Then
        frmMain.AllDocFunctions
    End If
    
    With rtText.Font
        .Name = dFont
        .Size = dFontSize
        .Bold = dFontBold
        .Italic = dFontItalic
        .Underline = dFontUnderline
    End With
    
    trapUndo = True
    
    If Len(Filename) = 0 Then
        Unsaved = True
        Locked = True
        
        Me.Caption = "Untitled:" & (DocCount + 1)
        Locked = False
    Else
        rtText.LoadFile Filename, 1
        If IsTemplate Then
            Me.Caption = "Untitled:" & (DocCount + 1)
            Me.Filename = ""
            Me.Unsaved = True
        Else
            Me.Caption = Filename
            Unsaved = False
        End If
    End If
    
    rtText_Change       ' Initialize undo stack with blank doc
    rtText_SelChange    '     "      edit menus
    
    DocKey = CStr(FreeNum)
    frmMain.Documents.Add Me, DocKey
    FreeNum = FreeNum + 1
        
    SetModified False
End Sub

Private Sub Form_Resize()
Static LastWS As Integer
    If Me.WindowState = vbMinimized Then Exit Sub
    
    On Error Resume Next
    rtText.Width = ScaleWidth
    rtText.Height = ScaleHeight
    
    If LastWS <> Me.WindowState Then
        If Me.WindowState = vbMaximized Then
            DocMaximized = True
            rtText.Appearance = rtfFlat
        Else
            DocMaximized = False
            rtText.Appearance = rtfThreeD
        End If
        LastWS = Me.WindowState
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    If Not frmMain.ExitProcess Then
        ' user is not exiting whole program, just
        ' this document
        Cancel = AskSave
        If Cancel = 1 Then Exit Sub
    End If
    
    frmMain.Documents.Remove DocKey
    If frmMain.Documents.Count = 0 Then
        Set frmMain.CurrentDoc = Nothing
        frmMain.NoDocFunctions
    End If
End Sub

Public Sub CloseDoc()
    Unload Me
End Sub

Private Sub rtText_Change()
    If Not Locked Then
        SetModified True
    End If
    
    If Not trapUndo Then Exit Sub 'because trapping is disabled

    Dim newElement As New UndoElement   'create new undo element
    Dim C%, L&

    'remove all redo items because of the change
    For C% = 1 To RedoStack.Count
        RedoStack.Remove 1
    Next C%

    'set the values of the new element
    newElement.SelStart = rtText.SelStart
    newElement.TextLen = Len(rtText.Text)
    newElement.Text = rtText.Text

    'add it to the undo stack
    UndoStack.Add item:=newElement
    If UndoStack.Count > 100 Then UndoStack.Remove 1
    
    'enable controls accordingly
    frmMain.UpdateUndoFunctions
End Sub

Private Sub rtText_KeyDown(KeyCode As Integer, Shift As Integer)
    If Shift And vbCtrlMask Then
        If KeyCode > vbKey0 And KeyCode < vbKey7 Then
            InsertSurroundTag CaseTag("<H") & CStr(KeyCode - vbKey0) & ">", _
                CaseTag("</H") & CStr(KeyCode - vbKey0) & ">"
        Else
            Select Case KeyCode
            Case vbKeyZ
                frmMain.mnuEditUndo_Click
                KeyCode = 0
            Case vbKeyV
                rtText.SelText = ""
                Call SendMessage(rtText.hWnd, WM_PASTE, 0, 0&)
                KeyCode = 0
            Case vbKeyReturn
                InsertTag CaseTag("<P>")
                KeyCode = 0
            Case vbKeySpace
                InsertTag "&nbsp;"
                KeyCode = 0
            End Select
        End If
    ElseIf Shift And vbShiftMask Then
        If KeyCode = vbKeyReturn Then
            InsertTag CaseTag("<BR>")
            KeyCode = 0
        End If
    End If
End Sub

Private Sub rtText_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button = vbRightButton Then
        PopupMenu frmMain.mnuEdit, , x, y
    End If
End Sub

Private Sub rtText_SelChange()
Dim Ln As Long
    Ln = rtText.SelLength
    
    With frmMain
        ' Determine which options are available
        .mnuEditCut.Enabled = Ln
        .mnuEditCopy.Enabled = Ln
        .mnuEditDelete.Enabled = Ln
        .mnuEditStrip.Enabled = Ln
        .mnuConvertLower.Enabled = Ln
        .mnuConvertProper.Enabled = Ln
        .mnuConvertUpper.Enabled = Ln
        .mnuEditConvertEntities.Enabled = Ln
    End With
    
    With frmMain.Toolbar1.Buttons
        .item("Cut").Enabled = Ln
        .item("Copy").Enabled = Ln
    End With
End Sub

' Repeatedly check the current line

Private Sub Timer1_Timer()
Static LastLine As Long
Dim C As Long
    C = rtText.GetLineFromChar(rtText.SelStart) + 1
    If C <> LastLine Then
        Status.Text = "Line: " & CStr(C)
        LastLine = C
    End If
End Sub

' SaveTemp generates a random temp file name and saves
' the file.  The docuement's Unsaved attribute is left
' unchanged, so that the user is required to save it later
' under a normal filename.
'
' The function is called before testing an unsaved file in
' a browser, or for a timed AutoSave on an unsaved file.
'
Public Sub SaveTemp()
Dim A%, B%, C$, F$
    If Len(Me.Tempname) > 0 Then
        rtText.SaveFile Me.Tempname, 1
        Exit Sub
    End If
    
    Randomize Timer
    
    ' Generate random filename
    A = CInt(Rnd * (Rnd * 100))
    B = CInt((vbKeyZ - vbKeyA + 1) * Rnd + vbKeyA)
    C$ = Chr$(B)
    F$ = AppPath & C$ & CStr(A) & ".tmp.html"
    
    ' Save the file
    rtText.SaveFile F$, 1
    
    ' Remember it so we can recover it after a
    ' crash if necessary
    TempFiles.Add F$, F$
    FileDumpCol TempFiles, AppPath & "tempdoc.his"
    Me.Tempname = F$
End Sub

' Insert text
Public Sub InsertTag(Tag$)
    rtText.SelText = Tag$
End Sub

' Insert a tag surrounding the selected text, or, if there is
' none, insert the tag set and put the cursor in between the
' opening and closing tags.
'
Public Sub InsertSurroundTag(BeginTag$, EndTag$)
Dim T$
    T$ = rtText.SelText
    
    rtText.SelText = ""
    rtText.SelText = BeginTag & T$ & EndTag
    If Len(T$) = 0 Then
        rtText.SelStart = rtText.SelStart - Len(EndTag)
    End If
End Sub

' AskSave = 1 if user canceled the request
Private Function AskSave() As Integer
    If Modified Then
        Dim R As VbMsgBoxResult
        R = MsgBox("Save changes to " & Me.Caption & "?", _
            vbQuestion Or vbYesNoCancel, "Just a moment...")
        Select Case R
        Case vbYes
            If Unsaved Then
                frmMain.mnuFileSaveAs_Click
            Else
                rtText.SaveFile Filename, 1
            End If
            AskSave = 0
        Case vbNo
            AskSave = 0
        Case vbCancel
            AskSave = 1
            Exit Function
        End Select
    End If
    
    ' If user wishes to discard, then remove temporary
    ' file
    If Len(Me.Tempname) > 0 Then
        TempFiles.Remove Tempname
        Kill Tempname
        FileDumpCol TempFiles, AppPath & "tempdoc.his"
        Me.Tempname = ""
    End If
End Function

Public Sub PrintContents()
    PrintRTF rtText, 1440, 1440, 1440, 1440
End Sub

Private Sub PrintRTF(RTF As RichTextBox, LeftMarginWidth As Long, _
    TopMarginHeight, RightMarginWidth, BottomMarginHeight)
Dim LeftOffset As Long, TopOffset As Long
Dim LeftMargin As Long, TopMargin As Long
Dim RightMargin As Long, BottomMargin As Long
Dim fr As FormatRange
Dim rcDrawTo As Rect
Dim rcPage As Rect
Dim TextLength As Long
Dim NextCharPosition As Long
Dim R As Long
    
    ' Start a print job to get a valid Printer.hDC
    Printer.Print Space(1)
    Printer.ScaleMode = vbTwips
    
    ' Get the offsett to the printable area on the page in twips
    LeftOffset = Printer.ScaleX(GetDeviceCaps(Printer.hdc, _
       PHYSICALOFFSETX), vbPixels, vbTwips)
    TopOffset = Printer.ScaleY(GetDeviceCaps(Printer.hdc, _
       PHYSICALOFFSETY), vbPixels, vbTwips)
    
    ' Calculate the Left, Top, Right, and Bottom margins
    LeftMargin = LeftMarginWidth - LeftOffset
    TopMargin = TopMarginHeight - TopOffset
    RightMargin = (Printer.Width - RightMarginWidth) - LeftOffset
    BottomMargin = (Printer.Height - BottomMarginHeight) - TopOffset
    
    ' Set printable area rect
    rcPage.Left = 0
    rcPage.Top = 0
    rcPage.Right = Printer.ScaleWidth
    rcPage.Bottom = Printer.ScaleHeight
    
    ' Set rect in which to print (relative to printable area)
    rcDrawTo.Left = LeftMargin
    rcDrawTo.Top = TopMargin
    rcDrawTo.Right = RightMargin
    rcDrawTo.Bottom = BottomMargin
    
    ' Set up the print instructions
    fr.hdc = Printer.hdc   ' Use the same DC for measuring and rendering
    fr.hdcTarget = Printer.hdc  ' Point at printer hDC
    fr.rc = rcDrawTo            ' Indicate the area on page to draw to
    fr.rcPage = rcPage          ' Indicate entire size of page
    fr.chrg.cpMin = 0           ' Indicate start of text through
    fr.chrg.cpMax = -1          ' end of the text
    
    ' Get length of text in RTF
    TextLength = Len(RTF.Text)
    
    ' Loop printing each page until done
    Do
       ' Print the page by sending EM_FORMATRANGE message
       NextCharPosition = SendMessage(RTF.hWnd, EM_FORMATRANGE, True, fr)
       If NextCharPosition >= TextLength Then Exit Do  'If done then exit
       fr.chrg.cpMin = NextCharPosition ' Starting position for next page
       Printer.NewPage                  ' Move on to next page
       Printer.Print Space(1) ' Re-initialize hDC
       fr.hdc = Printer.hdc
       fr.hdcTarget = Printer.hdc
    Loop
    
    ' Commit the print job
    Printer.EndDoc
    
    ' Allow the RTF to free up memory
    R = SendMessage(RTF.hWnd, EM_FORMATRANGE, False, ByVal CLng(0))
End Sub

Public Sub Redo()
Dim chg$
Dim DeleteFlag As Boolean 'flag as to whether or not to delete text or append text
Dim objElement As Object
    If RedoStack.Count > 0 And trapUndo Then
        trapUndo = False
        DeleteFlag = RedoStack(RedoStack.Count).TextLen < Len(rtText.Text)
        If DeleteFlag Then  'delete last item
            Set objElement = RedoStack(RedoStack.Count)
            rtText.SelStart = objElement.SelStart
            rtText.SelLength = Len(rtText.Text) - objElement.TextLen
            rtText.SelText = ""
        Else 'append something
            Set objElement = RedoStack(RedoStack.Count)
            chg$ = Change(rtText.Text, objElement.Text, objElement.SelStart + 1)
            rtText.SelStart = objElement.SelStart - Len(chg$)
            rtText.SelLength = 0
            rtText.SelText = chg$
            rtText.SelStart = objElement.SelStart - Len(chg$)
            If Len(chg$) > 1 And chg$ <> vbCrLf Then
                rtText.SelLength = Len(chg$)
            Else
                rtText.SelStart = rtText.SelStart + Len(chg$)
            End If
        End If
        UndoStack.Add item:=objElement
        RedoStack.Remove RedoStack.Count
    End If
    frmMain.UpdateUndoFunctions
    trapUndo = True
End Sub

Public Sub Undo()
Dim chg$, x&
Dim DeleteFlag As Boolean 'flag as to whether or not to delete text or append text
Dim objElement As Object, objElement2 As Object
    If UndoStack.Count > 1 And trapUndo Then 'we can proceed
        trapUndo = False
        DeleteFlag = UndoStack(UndoStack.Count - 1).TextLen < UndoStack(UndoStack.Count).TextLen
        If DeleteFlag Then  'delete some text
            cmdDummy.SetFocus   'change focus of form
            x& = SendMessage(rtText.hWnd, EM_HIDESELECTION, 1&, 1&)
            Set objElement = UndoStack(UndoStack.Count)
            Set objElement2 = UndoStack(UndoStack.Count - 1)
            rtText.SelStart = objElement.SelStart - (objElement.TextLen - objElement2.TextLen)
            rtText.SelLength = objElement.TextLen - objElement2.TextLen
            rtText.SelText = ""
            x& = SendMessage(rtText.hWnd, EM_HIDESELECTION, 0&, 0&)
        Else 'append something
            Set objElement = UndoStack(UndoStack.Count - 1)
            Set objElement2 = UndoStack(UndoStack.Count)
            chg$ = Change(objElement.Text, objElement2.Text, _
                objElement2.SelStart + 1 + Abs(Len(objElement.Text) - Len(objElement2.Text)))
            rtText.SelStart = objElement2.SelStart
            rtText.SelLength = 0
            rtText.SelText = chg$
            rtText.SelStart = objElement2.SelStart
            If Len(chg$) > 1 And chg$ <> vbCrLf Then
                rtText.SelLength = Len(chg$)
            Else
                rtText.SelStart = rtText.SelStart + Len(chg$)
            End If
        End If
        RedoStack.Add item:=UndoStack(UndoStack.Count)
        UndoStack.Remove UndoStack.Count
    End If
    frmMain.UpdateUndoFunctions
    trapUndo = True
    rtText.SetFocus
End Sub

Private Function Change(ByVal lParam1 As String, ByVal lParam2 As String, startSearch As Long) As String
Dim tempParam$
Dim D&
    If Len(lParam1) > Len(lParam2) Then 'swap
        tempParam$ = lParam1
        lParam1 = lParam2
        lParam2 = tempParam$
    End If
    D& = Len(lParam2) - Len(lParam1)
    Change = Mid(lParam2, startSearch - D&, D&)
End Function

Public Sub SetModified(M As Boolean)
    Modified = M
    With frmMain
        .StatusBar1.Panels(2).Text = IIf(M, "(Modified)", "")
        .Toolbar1.Buttons("Save").Enabled = M
    End With
End Sub
