VERSION 5.00
Begin VB.Form frmContextInput 
   BackColor       =   &H00FFC0C0&
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   1035
   ClientLeft      =   15
   ClientTop       =   15
   ClientWidth     =   3675
   ControlBox      =   0   'False
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1035
   ScaleWidth      =   3675
   StartUpPosition =   3  'Windows Default
   Visible         =   0   'False
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2640
      TabIndex        =   3
      Top             =   600
      Width           =   855
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1560
      TabIndex        =   2
      Top             =   600
      Width           =   855
   End
   Begin VB.ComboBox Combo1 
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   120
      TabIndex        =   1
      Top             =   240
      Width           =   3495
   End
   Begin VB.Label Label1 
      BackColor       =   &H80000018&
      BackStyle       =   0  'Transparent
      Caption         =   "Enter Directory"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   9
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   0
      Width           =   3615
   End
End
Attribute VB_Name = "frmContextInput"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'    Blue Ice HTML Editor
'    Copyright (C) 1999  Joel Dueck
'
'    This program is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

Option Explicit

Public Text As String           ' User input for all to see
Public Canceled As Boolean      ' Did user cancel

Private m_colList As Collection ' Collection for AutoComplete
                                ' entries

Private NoAuto As Boolean       ' Whether to use AutoComplete
Private Locked As Boolean

Private Sub cmdCancel_Click()
    Canceled = True
    Unload Me
End Sub

Private Sub cmdOK_Click()
    Canceled = False
    Unload Me
End Sub

Private Sub Combo1_Change()
Static t$
    If Locked Then Exit Sub
    If Len(Combo1.Text) > Len(t$) Then      ' user did not delete text
        t$ = Combo1.Text
        Locked = True
        AutoComplete Combo1
        Locked = False
    Else
        t$ = Combo1.Text
    End If
    Text = Combo1.Text
End Sub

Public Sub ShowInput(ICaption$)
    If Len(ICaption) > 0 Then
        Label1.Caption = ICaption$
    End If
    Me.Show
End Sub

Property Get Prompt() As String
    Prompt = Label1.Caption
End Property

Property Let Prompt(P$)
    Label1.Caption = P$
End Property

Public Function GetList() As Collection
    Set GetList = m_colList
End Function

Public Sub SetList(C As Collection)
Dim I%
    Set m_colList = C
    
    If C Is Nothing Then
        NoAuto = True
        Exit Sub
    Else
        NoAuto = False
    End If
    
    If m_colList.Count > 0 Then
        Combo1.Clear
        
        For I = 1 To m_colList.Count
            Combo1.AddItem m_colList(I)
        Next I
    End If
End Sub

