VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmNew 
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   2820
   ClientLeft      =   15
   ClientTop       =   15
   ClientWidth     =   3855
   ControlBox      =   0   'False
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2820
   ScaleWidth      =   3855
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdOther 
      Caption         =   "O&ther..."
      Height          =   375
      Left            =   2760
      TabIndex        =   7
      Top             =   1800
      Width           =   975
   End
   Begin VB.CommandButton cmdRemove 
      Caption         =   "&Remove"
      Enabled         =   0   'False
      Height          =   375
      Left            =   2760
      TabIndex        =   6
      Top             =   2280
      Width           =   975
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   2760
      TabIndex        =   5
      Top             =   1200
      Width           =   975
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   2760
      TabIndex        =   4
      Top             =   720
      Width           =   975
   End
   Begin VB.ListBox lstTemplate 
      Appearance      =   0  'Flat
      Height          =   1980
      Left            =   120
      TabIndex        =   3
      Top             =   720
      Width           =   2535
   End
   Begin VB.PictureBox picTitle 
      Align           =   1  'Align Top
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   0
      ScaleHeight     =   225
      ScaleWidth      =   3825
      TabIndex        =   0
      Top             =   0
      Width           =   3855
      Begin VB.Label lblTitle 
         BackStyle       =   0  'Transparent
         Caption         =   "New Document"
         BeginProperty Font 
            Name            =   "Verdana"
            Size            =   9
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   0
         TabIndex        =   1
         Top             =   0
         Width           =   2295
      End
   End
   Begin MSComDlg.CommonDialog cdgDialog 
      Left            =   3240
      Top             =   360
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      DialogTitle     =   "Open as Template"
      Filter          =   "HTML files (*.html, *.htm, *.shtml)|*.html;*.htm;*.shtml|All files (*.*)|*.*"
   End
   Begin VB.Label Label1 
      Caption         =   "Template:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   480
      Width           =   1455
   End
End
Attribute VB_Name = "frmNew"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'    Blue Ice HTML Editor
'    Copyright (C) 1999  Joel Dueck
'
'    This program is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

Option Explicit

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdOK_Click()
    Me.Hide
    If lstTemplate.Text = "(none)" Then
        Dim Dc As frmDoc
        Set Dc = New frmDoc
        Dc.Show
        
        If FastStart Then
            frmStartdoc.Show vbModal, frmMain
        End If
    Else
        frmMain.OpenFile Templates(lstTemplate.ListIndex), False, True
    End If
    Unload Me
End Sub

Private Sub cmdOther_Click()
Dim T$
    On Error GoTo Canceled
    With cdgDialog
        .Flags = cdlOFNHideReadOnly Or cdlOFNFileMustExist
        .ShowOpen
        
        T$ = InputBox("Enter a name for this template:", "New Template", _
            GetFilePart(.Filename, kfpFilename))
        
        If LCase$(Right$(T$, 5)) <> ".html" And LCase$(Right$(T$, 4)) <> ".htm" Then
            T$ = T$ & ".html"
        End If
        
        FileCopy .Filename, AppPath & "templates\" & T$
        
        lstTemplate.AddItem T$
        Templates.Add AppPath & "templates\" & T$, AppPath & "templates\" & T$
    End With
Canceled:
End Sub

' This does not delete a file, only removes it from the list
'
Private Sub cmdRemove_Click()
Dim I%, Name$
    I = lstTemplate.ListIndex
    Name = lstTemplate.Text
    
    lstTemplate.RemoveItem I
    Templates.Remove I
End Sub

Private Sub Form_Load()
Dim I%
    Me.Left = (Screen.Width - Me.Width) / 2
    Me.Top = (Screen.Height - Me.Height) / 2
    SetTitlebar picTitle, lblTitle
    
    lstTemplate.AddItem "(none)"
    
    For I = 1 To Templates.Count
        lstTemplate.AddItem GetFilePart(Templates(I), kfpFilename)
    Next I
    lstTemplate.ListIndex = 0
End Sub

Private Sub lblTitle_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Dim lReturn As Long
       Call ReleaseCapture
       lReturn = SendMessage(Me.hWnd, WM_SYSCOMMAND, MOUSE_MOVE, 0)
End Sub

Private Sub lstTemplate_Click()
    cmdRemove.Enabled = True
End Sub

Private Sub lstTemplate_DblClick()
    cmdOK_Click
End Sub

Private Sub picTitle_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Dim lReturn As Long
       Call ReleaseCapture
       lReturn = SendMessage(Me.hWnd, WM_SYSCOMMAND, MOUSE_MOVE, 0)
End Sub

