VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmStartdoc 
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   2805
   ClientLeft      =   15
   ClientTop       =   15
   ClientWidth     =   4710
   ControlBox      =   0   'False
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2805
   ScaleWidth      =   4710
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   3600
      TabIndex        =   8
      Top             =   2280
      Width           =   975
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   2400
      TabIndex        =   7
      Top             =   2280
      Width           =   975
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "..."
      Height          =   255
      Index           =   1
      Left            =   4200
      TabIndex        =   4
      Top             =   1080
      Width           =   375
   End
   Begin VB.TextBox txtStylesheet 
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   2040
      TabIndex        =   3
      Top             =   1080
      Width           =   2055
   End
   Begin VB.TextBox txtKeywords 
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   2040
      TabIndex        =   6
      Top             =   1800
      Width           =   2535
   End
   Begin VB.TextBox txtDesc 
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   2040
      TabIndex        =   5
      Top             =   1440
      Width           =   2535
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "..."
      Height          =   255
      Index           =   0
      Left            =   4200
      TabIndex        =   2
      Top             =   720
      Width           =   375
   End
   Begin VB.TextBox txtBgimage 
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   2040
      TabIndex        =   1
      Top             =   720
      Width           =   2055
   End
   Begin MSComDlg.CommonDialog cdgDialog 
      Left            =   120
      Top             =   2400
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
   End
   Begin VB.TextBox txtTitle 
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   2040
      TabIndex        =   0
      Top             =   360
      Width           =   2535
   End
   Begin VB.PictureBox picTitle 
      Align           =   1  'Align Top
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   0
      ScaleHeight     =   225
      ScaleWidth      =   4680
      TabIndex        =   9
      Top             =   0
      Width           =   4710
      Begin VB.Label lblTitle 
         BackStyle       =   0  'Transparent
         Caption         =   "Fast Start"
         BeginProperty Font 
            Name            =   "Verdana"
            Size            =   9
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   0
         TabIndex        =   10
         Top             =   0
         Width           =   2295
      End
   End
   Begin VB.Label Label5 
      Caption         =   "Stylesheet:"
      Height          =   255
      Left            =   120
      TabIndex        =   15
      Top             =   1080
      Width           =   1335
   End
   Begin VB.Label Label4 
      Caption         =   "Keywords:"
      Height          =   255
      Left            =   120
      TabIndex        =   14
      Top             =   1800
      Width           =   1455
   End
   Begin VB.Label Label3 
      Caption         =   "Description:"
      Height          =   255
      Left            =   120
      TabIndex        =   13
      Top             =   1440
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "Background image:"
      Height          =   255
      Left            =   120
      TabIndex        =   12
      Top             =   720
      Width           =   1695
   End
   Begin VB.Label Label1 
      Caption         =   "Title:"
      Height          =   255
      Left            =   120
      TabIndex        =   11
      Top             =   360
      Width           =   1215
   End
End
Attribute VB_Name = "frmStartdoc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'    Blue Ice HTML Editor
'    Copyright (C) 1999  Joel Dueck
'
'    This program is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

Option Explicit

Const HEADER_COMMENT = "<!--   Created using Blue Ice HTML Editor   -->" & _
    vbCrLf & "<!--   http://www.stormloader.com/jdueck/ice  -->"
Public Docptr As frmDoc

Private Sub cmdBrowse_Click(Index As Integer)
    On Error GoTo Canceled
    With cdgDialog
        Select Case Index
        Case 0
            .InitDir = ImgDrive & ImgPath
            .DialogTitle = "Select Background Image"
            .Filter = "Image Files (*.gif, *.jpeg, *.jpg, *.png)|*.gif;*.jpeg;*.jpg;*.png|All Files (*.*)|*.*"
        Case 1
            .InitDir = LastSaveDir
            .DialogTitle = "Select Stylesheet"
            .Filter = "Stylesheets (*.css)|*.css|All Files (*.*)|*.*"
        End Select
        
        .Flags = cdlOFNFileMustExist Or cdlOFNHideReadOnly
        .ShowOpen
        
        Select Case Index
        Case 0
            txtBgimage.Text = GetFilePart(.Filename, kfpFilename)
        Case 1
            txtStylesheet.Text = GetFilePart(.Filename, kfpFilename)
        End Select
    End With
Canceled:
End Sub

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdOK_Click()
Dim Tstamp$, Tags$
    Tags$ = Tags$ & CaseTag("<HTML>") & vbCrLf & HEADER_COMMENT & vbCrLf
    Tstamp = Format(Now, "dddd, mmm d yyyy") & " " & Format(Time, "Medium Time")
    Tags$ = Tags$ & "<!--" & Space((39 - Len(Tstamp)) / 2) & Tstamp & Space((39 - Len(Tstamp)) / 2) & "-->" & vbCrLf
    Tags$ = Tags$ & CaseTag("<HEAD>") & vbCrLf
    Tags$ = Tags$ & CaseTag("  <TITLE>") & txtTitle.Text & CaseTag("</TITLE>") & vbCrLf
    Tags$ = Tags$ & CaseTag("  <META name=") & QuoteStr("description") & _
        CaseTag(" content=") & QuoteStr(txtDesc.Text) & ">" & vbCrLf
    Tags$ = Tags$ & CaseTag("  <Meta name=") & QuoteStr("keywords") & _
        CaseTag(" content=") & QuoteStr(txtKeywords.Text) & ">" & vbCrLf
    Tags$ = Tags$ & CaseTag("</HEAD>") & vbCrLf
    
    If Len(txtStylesheet.Text) > 0 Then Tags$ = Tags$ & CaseTag("<LINK REL=") & _
        "StyleSheet" & CaseTag(" HREF=") & QuoteStr(txtStylesheet.Text) & _
        CaseTag(" TYPE=") & QuoteStr("text/css") & ">" & vbCrLf
    
    Tags$ = Tags$ & CaseTag("<BODY")
    
    If Len(txtBgimage.Text) > 0 Then Tags$ = Tags$ & CaseTag(" background=") & QuoteStr(txtBgimage.Text)
    Tags$ = Tags$ & ">" & vbCrLf & vbCrLf & vbCrLf & CaseTag("</BODY>") & _
        vbCrLf & CaseTag("</HTML>")
    
    frmMain.CurrentDoc.rtText.SelText = Tags
    Unload Me
End Sub

Private Sub Form_Load()
    Me.Left = (Screen.Width - Me.Width) / 2
    Me.Top = (Screen.Height - Me.Height) / 2
    SetTitlebar picTitle, lblTitle
End Sub

Private Sub lblTitle_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Dim lReturn As Long
       Call ReleaseCapture
       lReturn = SendMessage(Me.hWnd, WM_SYSCOMMAND, MOUSE_MOVE, 0)
End Sub

Private Sub picTitle_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Dim lReturn As Long
       Call ReleaseCapture
       lReturn = SendMessage(Me.hWnd, WM_SYSCOMMAND, MOUSE_MOVE, 0)
End Sub
