VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   Caption         =   "TextPad - Untitled"
   ClientHeight    =   5805
   ClientLeft      =   60
   ClientTop       =   630
   ClientWidth     =   8880
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   5805
   ScaleWidth      =   8880
   StartUpPosition =   2  'CenterScreen
   Begin MSComDlg.CommonDialog cDialog 
      Left            =   4200
      Top             =   2640
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.TextBox txtMain 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   5775
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   0
      Width           =   8895
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileNew 
         Caption         =   "&New"
         Shortcut        =   ^N
      End
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open..."
         Shortcut        =   ^O
      End
      Begin VB.Menu sep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileSave 
         Caption         =   "&Save"
         Shortcut        =   ^S
      End
      Begin VB.Menu mnuFileSaveAs 
         Caption         =   "Save &As..."
      End
      Begin VB.Menu sep2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFilePrintSetup 
         Caption         =   "Print Setup..."
      End
      Begin VB.Menu mnuFilePrint 
         Caption         =   "&Print"
         Shortcut        =   ^P
      End
      Begin VB.Menu sep3 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "&Edit"
      Begin VB.Menu mnuEditUndo 
         Caption         =   "&Undo"
         Shortcut        =   ^Z
      End
      Begin VB.Menu sep4 
         Caption         =   "-"
      End
      Begin VB.Menu mnuEditCut 
         Caption         =   "Cu&t"
         Shortcut        =   ^X
      End
      Begin VB.Menu mnuEditCopy 
         Caption         =   "&Copy"
         Shortcut        =   ^C
      End
      Begin VB.Menu mnuEditPaste 
         Caption         =   "&Paste"
         Shortcut        =   ^V
      End
      Begin VB.Menu mnuEditDelete 
         Caption         =   "De&lete"
         Shortcut        =   +{DEL}
      End
      Begin VB.Menu sep6 
         Caption         =   "-"
      End
      Begin VB.Menu mnuEditSelectAll 
         Caption         =   "Select &All"
         Shortcut        =   ^A
      End
      Begin VB.Menu mnuEditDateTime 
         Caption         =   "&Date/Time"
         Shortcut        =   {F4}
      End
   End
   Begin VB.Menu mnuSearch 
      Caption         =   "&Search"
      Begin VB.Menu mnuSearchFind 
         Caption         =   "&Find..."
         Shortcut        =   ^F
      End
      Begin VB.Menu mnuSearchFindNext 
         Caption         =   "Find &Next"
         Shortcut        =   {F3}
      End
      Begin VB.Menu sep7 
         Caption         =   "-"
      End
      Begin VB.Menu mnuSearchReplace 
         Caption         =   "&Replace"
         Shortcut        =   ^H
      End
   End
   Begin VB.Menu mnuTools 
      Caption         =   "&Tools"
      Begin VB.Menu mnuToolsWordCount 
         Caption         =   "&Word Count"
         Shortcut        =   ^W
      End
      Begin VB.Menu sep8 
         Caption         =   "-"
      End
      Begin VB.Menu mnuToolsEncode 
         Caption         =   "&Encode/Decode"
         Shortcut        =   {F5}
      End
      Begin VB.Menu sep9 
         Caption         =   "-"
      End
      Begin VB.Menu mnuToolsFont 
         Caption         =   "Set &Font"
         Shortcut        =   {F6}
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpQuick 
         Caption         =   "&Quick Help"
         Shortcut        =   {F1}
      End
      Begin VB.Menu sep10 
         Caption         =   "-"
      End
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About     "
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Form_Load()
    SetProperties (1)       'Set startup properties
End Sub

Private Sub Form_Resize()
    On Error Resume Next    'Resize the textbox as needed
      txtMain.Width = Me.Width - 105
      txtMain.Height = Me.Height - 720
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Call EndProg            'Call sub for end
End Sub

Private Sub EndProg()
    Call mnuFileNew_Click   'Call NEW sub
    End                     'End program
End Sub

Private Sub mnuEditCopy_Click()
    Clipboard.Clear         'Clear the clipboard
    Clipboard.SetText txtMain.SelText   'Copy selected text
    txtMain.SetFocus        'Set focus back to textbox
End Sub

Private Sub mnuEditCut_Click()
    Clipboard.Clear         'Clear the clipboard
    Clipboard.SetText txtMain.SelText   'Copy selected text
    txtMain.SelText = ""    'Clear selected text of main textbox
    txtMain.SetFocus        'Set focus back to textbox
    dChanged = True         'Document is Changed
End Sub

Private Sub mnuEditDateTime_Click()
    txtMain.SelText = Date + Time   'Insert date and time
End Sub

Private Sub mnuEditDelete_Click()
    txtMain.SelText = ""            'Clear selected text
End Sub

Private Sub mnuEditPaste_Click()
    txtMain.SelText = Clipboard.GetText 'Insert text from clipboard
    txtMain.SetFocus    'Set focus back to textbox
    dChanged = True     'Document is changed
End Sub

Private Sub mnuEditSelectAll_Click()
    txtMain.SelStart = 0    'Start selection from the beginning
    txtMain.SelLength = Len(txtMain.Text)   'Select the whole textbox
    txtMain.SetFocus        'Set focus back to textbox
End Sub

Private Sub mnuEditUndo_Click()
    SendKeys "^Z"   'Nice trick to do UNDO !
End Sub

Private Sub mnuFileExit_Click()
    Call EndProg    'Call sub for end
End Sub

Private Sub mnuFileNew_Click()
    If dChanged = False Then    'Check if document changed
        SetProperties (1)
      Else                      'Ask the user
        d = MsgBox("This document has been changed." & vbCrLf & vbCrLf & _
        "Do you want to save changes ?", vbYesNoCancel + vbQuestion, "Confirmation")
        If d = vbYes Then
            SaveFile (2)        'Save if user wants to
            If IsSaved <> -1 Then SetProperties (1)
          Else
            SetProperties (1)   'Leave it otherwise
        End If
    End If
End Sub

Private Sub mnuFileOpen_Click()
    If dChanged = False Then    'Check if document changed
        SetProperties (2)
        OpenFile
    Else                        'Ask the user
        d = MsgBox("This document has been changed." & vbCrLf & vbCrLf & _
        "Do you want to save changes ?", vbYesNoCancel + vbQuestion, "Confirmation")
        
        If d = vbYes Then   'Save if user wants
            If Len(FileName) > 1 Then
                SaveFile (1)
            Else
                SaveFile (2)
                If IsSaved <> -1 Then SetProperties (1)
            End If
            
            SetProperties (2)
            OpenFile

        Else
            SetProperties (2)
            OpenFile
        End If
    End If
End Sub

Private Sub mnuFilePrint_Click()
    On Error GoTo PrintCanceled:    'If error occurs toto error handler
    
    cDialog.Flags = DefaultFlags    'Print the document
    cDialog.ShowPrinter
    Printer.Copies = cDialog.Copies
    Printer.CurrentX = 100
    Printer.CurrentY = 100
    Printer.FontName = txtMain.FontName
    Printer.FontSize = txtMain.FontSize
    Printer.Print txtMain.Text
    MsgBox "Printing...", vbOKOnly, "Printing..."

PrintCanceled:                      'Error occured !
    MsgBox "Printing Error ! Check if your printer is ON and there are enough paper."
End Sub

Private Sub mnuFilePrintSetup_Click()
    On Error Resume Next
      cDialog.ShowPrinter   'Show printer dialog box
End Sub

Private Sub mnuFileSave_Click()
    If Len(FileName) > 1 Then   'Save the document
        SaveFile (1)
        SetProperties (3)
    Else
        SaveFile (2)
        SetProperties (3)
    End If
End Sub

Private Sub mnuFileSaveAs_Click()
    SaveFile (2)
    SetProperties (4)
End Sub

Private Sub mnuHelpAbout_Click()
    frmAbout.Show 1, Me
End Sub

Private Sub mnuHelpQuick_Click()
    frmHelp.Show 1, Me
End Sub

Private Sub mnuSearchFind_Click()
    frmFind.Show , Me
End Sub

Private Sub mnuSearchFindNext_Click()
    'Get the previously finded item and find it again
    lngPos = frmMain.txtMain.SelStart + frmMain.txtMain.SelLength
    lngResult = InStr(lngPos, frmMain.txtMain.Text, FindString)
        
    If lngResult = 0 Then
        MsgBox "Document searched. No such text found !", vbInformation, "TextPad"
        frmMain.mnuSearchFindNext.Enabled = False
      Else
        frmMain.txtMain.SetFocus
        frmMain.txtMain.SelStart = lngResult - 1
        frmMain.txtMain.SelLength = Len(FindString)
        frmMain.mnuSearchFindNext.Enabled = True
    End If
End Sub

Private Sub mnuSearchReplace_Click()
    frmReplace.Show , Me
End Sub

Private Sub mnuToolsEncode_Click()
  'Encode/Decode using Base64 Encoding System
  Dim TempStr As String

    If Len(txtMain.Text) = 0 Then Exit Sub
    frmPassword.Show 1
    If Right$(txtMain.Text, 1) = "*" Then
        TempStr = base64_decode(Mid$(txtMain.Text, 1, Len(txtMain.Text) - 1))
        TempStr = Left$(TempStr, Len(TempStr) - Len(Password))
        txtMain.Text = TempStr
      Else
        TempStr = txtMain.Text + Password
        TempStr = base64_encode(TempStr)
        TempStr = TempStr + "*"
        txtMain.Text = TempStr
    End If
End Sub

Private Sub mnuToolsFont_Click()
    'Show font dialog box and change the textbox property as needed
    cDialog.Flags = cdlCFBoth
    cDialog.ShowFont
    txtMain.Font = cDialog.FontName
    txtMain.FontSize = cDialog.FontSize
    txtMain.FontBold = cDialog.FontBold
    txtMain.FontItalic = cDialog.FontItalic
    txtMain.FontUnderline = cDialog.FontUnderline
End Sub

Private Sub mnuToolsWordCount_Click()
    frmCount.Show 1, Me
End Sub

Private Sub txtMain_Change()
    SetProperties (4)
End Sub

